"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MiddlewareFactory;
(function (MiddlewareFactory) {
    function resolve(middlewares, resolver) {
        var result = [];
        if (!middlewares)
            return result;
        for (var _i = 0, middlewares_1 = middlewares; _i < middlewares_1.length; _i++) {
            var middleware = middlewares_1[_i];
            if (typeof middleware == "string") {
                try {
                    var instance = resolver.resolve(middleware);
                    result.push(instance);
                }
                catch (e) {
                    throw new Error("Can not instantiate middleware [" + middleware + "] in global middlewares");
                }
            }
            else {
                result.push(middleware);
            }
        }
        return result;
    }
    MiddlewareFactory.resolve = resolve;
})(MiddlewareFactory = exports.MiddlewareFactory || (exports.MiddlewareFactory = {}));
