"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
require("reflect-metadata");
var Core = require("kamboja-core");
var invoker_1 = require("./invoker");
var _1 = require("../../");
var invocations_1 = require("./invocations");
var RequestHandler = (function () {
    function RequestHandler(option, context, response, target) {
        this.option = option;
        this.context = context;
        this.response = response;
        this.target = target;
    }
    RequestHandler.prototype.execute = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var invoker, invocation, routeInfo, result, e_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        invoker = new invoker_1.Invoker(this.option);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        invocation = void 0;
                        routeInfo = void 0;
                        if (!this.target) {
                            invocation = new invocations_1.ErrorInvocation(new _1.HttpStatusError(404, "Requested url not found"));
                        }
                        else if (this.target instanceof Error)
                            invocation = new invocations_1.ErrorInvocation(this.target);
                        else {
                            routeInfo = this.target;
                            invocation = new invocations_1.HttpControllerInvocation(this.option, this.context, routeInfo);
                        }
                        return [4 /*yield*/, invoker.invoke(this.context, invocation)];
                    case 2:
                        result = _a.sent();
                        return [4 /*yield*/, result.execute(this.context, this.response, routeInfo)];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        e_1 = _a.sent();
                        this.response.send(new Core.ActionResult(e_1.message, e_1.status || 500));
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return RequestHandler;
}());
exports.RequestHandler = RequestHandler;
