"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var qualified_name_1 = require("./qualified-name");
var DefaultDependencyResolver = (function () {
    function DefaultDependencyResolver(idResolver, pathResolver) {
        this.idResolver = idResolver;
        this.pathResolver = pathResolver;
    }
    DefaultDependencyResolver.prototype.resolve = function (id) {
        var name = this.idResolver.getClassName(id);
        var qualified = new qualified_name_1.QualifiedName(name, this.pathResolver);
        var instance = require(this.pathResolver.resolve(qualified.fileName));
        var classParts = qualified.className.split(".");
        classParts.forEach(function (x) { return instance = instance[x]; });
        return new instance();
    };
    return DefaultDependencyResolver;
}());
exports.DefaultDependencyResolver = DefaultDependencyResolver;
