"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var kamboja_core_1 = require("kamboja-core");
var ClassNotInherritedFromControllerAnalyzer = (function () {
    function ClassNotInherritedFromControllerAnalyzer() {
    }
    ClassNotInherritedFromControllerAnalyzer.prototype.analyse = function (route) {
        if (route.analysis && route.analysis.some(function (x) { return x == kamboja_core_1.RouteAnalysisCode.ClassNotInheritedFromController; })) {
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.ClassNotInheritedFromController,
                    type: "Warning",
                    message: "Class not inherited from Controller, ApiController or SocketController in [" + route.qualifiedClassName + "]"
                }];
        }
    };
    return ClassNotInherritedFromControllerAnalyzer;
}());
exports.ClassNotInherritedFromControllerAnalyzer = ClassNotInherritedFromControllerAnalyzer;
